function b = has(o, dname)

% Return true iff the prior contains at least one parameter with the given distribution.
%
% INPUTS
% - o      [dprior]   Prior object.
% - dname  [char]     Distribution name: 'uniform', 'gaussian', 'gamma',
%                     'beta', 'invgamma1', 'invgamma2', or 'weibull'.
%
% OUTPUTS
% - b      [logical]  scalar.

% Copyright © 2026 Dynare Team
%
% This file is part of Dynare.
%
% Dynare is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% Dynare is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

switch dname
  case 'uniform'
    b = ~isempty(o.iduniform);
  case 'gaussian'
    b = ~isempty(o.idgaussian);
  case 'gamma'
    b = ~isempty(o.idgamma);
  case 'beta'
    b = ~isempty(o.idbeta);
  case 'invgamma1'
    b = ~isempty(o.idinvgamma1);
  case 'invgamma2'
    b = ~isempty(o.idinvgamma2);
  case 'weibull'
    b = ~isempty(o.idweibull);
  otherwise
    error('dprior::has: unknown distribution (%s).', dname)
end
